/*
* Function return the device state by ID
* @in_sID {string}
* @in_oDevices {object} 
*/
function returnDeviceStateByID(in_sID, in_oDevices)
{
    var l_bState = false;
    for(var key in in_oDevices)
    {
        if(in_oDevices[key].ID == in_sID)
        {
            l_bState = in_oDevices[key].properties.value;
            break;
        }
    }
    return l_bState;
}

/***************************************************************************
 * FIBARO driver for BONGO based on AV & Custom Systems (HTTP)
 *
 * Version: 1.0
 *
 * Date: 17.04.2015
 *
 * Work with Fibaro HC2 and Fibaro HC Lite
 *
 ***************************************************************************/
var FibaroClass = function (in_Device) {
	//-------------------------------------------------------
	// Driver Data
	//-------------------------------------------------------
	this.DriverName = in_Device.Name;
	this.device = in_Device;
	this.json = '';
	this.text = '';
	this.version = '';
	this.deviceState = '';
	var modules = [];
	var curModule = 0;
	var that = this;

	//-------------------------------------------------------
	// Gets moduleID from Init.js and set parallel DeviceID <-> ModuleID
	//-------------------------------------------------------
	this.AddModule = function (in_Module) {
		modules.push(in_Module);
	}

	//-------------------------------------------------------
	// Device Initialization
	//-------------------------------------------------------
	this.Init = function () {
		that.device.Connect();
		//-------------------------------------------------------
		// Send request to receive information about version Fibaro
		//-------------------------------------------------------

		that.device.Send(['GET,/api/settings/info']);

	}

	//-------------------------------------------------------
	// Send request to receive a list of devices and setup interval for update device status
	//-------------------------------------------------------
	var GetDevices = function () {
		that.device.Send(['GET,/api/devices']);
		IR.SetInterval(3000, function () {
			that.device.Send(['GET,/api/devices/']);
		});
	}

	function getType(type) {

		var types = ["temperature", "door", "window", "flood", "smoke", "motion", "thermostat", "setpoint", "binaryswitch", "light", "multilevelswitch", "rgb"];
		for (var i = 0; i < types.length; i++) {
			if (type.toLowerCase().indexOf(types[i]) + 1 > 0) {
				return types[i];
			}
		}
		return "";
	}

	//-------------------------------------------------------
	// Processing  data from Fibaro
	//-------------------------------------------------------
	IR.AddListener(IR.EVENT_RECEIVE_TEXT, that.device, function (text) {
		that.text += text;
	});

	IR.AddListener(IR.EVENT_OFFLINE, that.device, function () {

		try {
			that.json = JSON.Parse(that.text);
		} catch (e) {
			IR.Log("Parser nyam-nyam not json");
		}

		//-------------------------------------------------------
		// Parse version and run GetDevices()
		//-------------------------------------------------------
		if (that.version == '') {
			that.version = parseInt(that.json.softVersion);
			that.text = '';
			GetDevices();
		}

		//-------------------------------------------------------
		// Parse list of device
		//-------------------------------------------------------
		else if (that.json instanceof Array) {
			var Devices = that.json;
			for (var y = 0; y < dataSetup.m_data.length; y++) {
            for (var i = 0; i < Devices.length; i++) {
				  for (var j = 0; j < modules.length; j++) {
               
					if (dataSetup.m_data[y].DEVICE_ID != Devices[i].id){
						continue;}
					if (false == modules[j].isCanUpdateInerface)
						continue;

					//IR.Log("прошли " + Devices[i].id+"  "+Devices[i].properties.value);
					var type = getType(Devices[i].type);
					that.deviceState = Devices[i].properties.value;
					/*if (!IR.GetVariable("Tokens.DevType")) {
						modules[j].callbackAfterGetType(modules[j], type);
					} */
					if (!type)
						continue;
               //IR.Log("ffffffffff2255552 " + Devices[i].name)   
					//if (!IR.GetVariable("Tokens.Name of device")) {
						//B.getModule(modules[j].ID).getVirtualTag("Name of device" + modules[j].ID).Value = "Device " + Devices[i].name;
						IR.SetVariable("Tokens.Name of device", "Device " + Devices[i].name);
					//}

					modules[j].callbackStatusChanged(Devices[i].enabled);
					switch (type) { //   модификация значений для фидбеков в зависимости от типа устройства
					case "multilevelswitch":
						IR.SetVariable("Drivers." + that.DriverName + ".Feedback2", (Devices[i].properties.value > 0 ? 0 : 1));
						break;
					case "door":
					case "window":
					case "flood":
					case "smoke":
					case "motion":
					case "binaryswitch":
						that.deviceState = (Devices[i].properties.value == "true") ? 0 : 1;
						break;
					case "rgb":
						var colorArr = Devices[i].properties.color.split(",");
						IR.SetVariable("Drivers." + that.DriverName + ".Feedback2", (Devices[i].properties.value > 0 ? 0 : 1));
						that.deviceState = (colorArr[0] << 24) | (colorArr[1] << 16) | (colorArr[2] << 8) | 0xFF;
						if (that.deviceState < 0) {
							that.deviceState += 0xFFFFFFFF;
						}
						break;
					}

					IR.SetVariable("Drivers." + that.DriverName + ".Feedback1", that.deviceState);

					 //IR.Log("~~~~~~~~~~~~ Feedback1 Real=" + IR.GetVariable("Drivers." + that.DriverName + ".Feedback1" + modules[j].ID));
					// IR.Log("~~~~~~~~~~~~ "+ modules[j]['Device ID'] +   IR.GetVariable("Drivers." + that.DriverName + ".Feedback1" + modules[j].ModuleID));

				}
			}
         }

		} else { //  ответ на команду

			IR.Log("~~~~~~~~~~~~~~~ответ на команду");
			for (var j = 0; j < modules.length; j++)
				modules[j].isCanUpdateInerface = true;
		}

		that.text = '';
      IR.GetItem("Page 3").GetItem("ID-186-Feedback").Value = returnDeviceStateByID("186", Devices);  //Here we get value and send it to the item
   });
}

//-------------------------------------------------------
// Creating instance FibaroClass
//-------------------------------------------------------
var ___FibaroDevice;
